SystemOrganization addCategory: #'Pier-Team'!

PRCase subclass: #PTPerson
	instanceVariableNames: 'birthDate skills email degree jobTitle positionInTeam'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Team'!

!PTPerson class methodsFor: 'as yet unclassified' stamp: 'tg 12/2/2008 21:50'!
canBeChildOf: aClass 
	^ aClass includesBehavior: PTTeam! !

!PTPerson class methodsFor: 'as yet unclassified' stamp: 'tg 4/14/2008 15:48'!
descriptionBio
	^ PRDocumentDescription new
		selectorAccessor: #skills;
		label: 'Skills';
		priority: 400;
		beEditable;
		yourself! !

!PTPerson class methodsFor: 'as yet unclassified' stamp: 'tg 4/15/2008 18:14'!
descriptionDegree
	^ MAStringDescription new
		selectorAccessor: #degree;
		label: 'Degree';
		priority: 140;
		beEditable;
		yourself! !

!PTPerson class methodsFor: 'as yet unclassified' stamp: 'tg 4/15/2008 18:14'!
descriptionEmail
	^ MAStringDescription new
		selectorAccessor: #email;
		label: 'Email';
		priority: 150;
		beEditable;
		yourself! !

!PTPerson class methodsFor: 'as yet unclassified' stamp: 'tg 4/15/2008 18:15'!
descriptionJobTitle
	^ MAStringDescription new
		selectorAccessor: #jobTitle;
		label: 'Job Title';
		priority: 145;
		beEditable;
		yourself! !

!PTPerson class methodsFor: 'as yet unclassified' stamp: 'tg 4/15/2008 21:32'!
descriptionPositionInTeam
	^ MANumberDescription new
		selectorAccessor: #positionInTeam;
		label: 'Position in team';
		priority: 110;
		beEditable;
		yourself! !

!PTPerson class methodsFor: 'as yet unclassified' stamp: 'tg 4/14/2008 15:50'!
isAbstract
	^false! !

!PTPerson methodsFor: 'as yet unclassified' stamp: 'tg 4/14/2008 15:53'!
accept: aVisitor
	aVisitor visitCase: self! !

!PTPerson methodsFor: 'accessing-properties' stamp: 'tg 4/15/2008 18:15'!
degree
	^degree! !

!PTPerson methodsFor: 'accessing-properties' stamp: 'tg 4/15/2008 18:15'!
degree: aString
	degree := aString! !

!PTPerson methodsFor: 'accessing-properties' stamp: 'tg 4/14/2008 15:49'!
email
	^email! !

!PTPerson methodsFor: 'accessing-properties' stamp: 'tg 4/14/2008 15:50'!
email: aString
	email := aString! !

!PTPerson methodsFor: 'accessing-properties' stamp: 'tg 4/15/2008 18:15'!
jobTitle
	^jobTitle! !

!PTPerson methodsFor: 'accessing-properties' stamp: 'tg 4/15/2008 18:15'!
jobTitle: aString
	jobTitle := aString! !

!PTPerson methodsFor: 'accessing-properties' stamp: 'tg 4/15/2008 21:30'!
positionInTeam
	^positionInTeam ifNil: [0]! !

!PTPerson methodsFor: 'accessing-properties' stamp: 'tg 4/15/2008 21:30'!
positionInTeam: aNumber
	positionInTeam := aNumber! !

!PTPerson methodsFor: 'accessing-properties' stamp: 'tg 4/14/2008 15:48'!
skills
	^skills! !

!PTPerson methodsFor: 'accessing-properties' stamp: 'tg 4/14/2008 15:49'!
skills: aString
	skills := aString! !

!PTPerson methodsFor: 'as yet unclassified' stamp: 'tg 12/2/2008 21:50'!
viewComponentClass
	^ PTPersonHtmlView! !

PRCase subclass: #PTTeam
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Team'!

!PTTeam class methodsFor: 'as yet unclassified' stamp: 'tg 12/2/2008 21:50'!
canBeParentOf: aClass 
	^ aClass includesBehavior: PTPerson! !

!PTTeam class methodsFor: 'as yet unclassified' stamp: 'tg 4/15/2008 17:49'!
isAbstract
	^false! !

!PTTeam methodsFor: 'pier-seasude' stamp: 'tg 4/15/2008 17:53'!
accept: aVisitor
	aVisitor visitCase: self! !

!PTTeam methodsFor: 'accessing' stamp: 'tg 12/2/2008 21:50'!
persons
	^ ((PRChildrenVisitor on: self) select: [ : each | each isKindOf: PTPerson ]) sort: [ : a : b | a positionInTeam < b positionInTeam ]! !

!PTTeam methodsFor: 'pier-seasude' stamp: 'tg 12/2/2008 21:51'!
viewComponentClass
	^ PTTeamHtmlView! !

PRDefaultView subclass: #PTPersonHtmlView
	instanceVariableNames: 'person'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Team'!

!PTPersonHtmlView class methodsFor: 'as yet unclassified' stamp: 'tg 12/2/2008 21:50'!
isValidIn: aContext 
	^ (super isValidIn: aContext) and: [ aContext structure isKindOf: PTPerson ]! !

!PTPersonHtmlView methodsFor: 'as yet unclassified' stamp: 'tg 12/2/2008 21:50'!
person
	^ person ifNil: [ person := self find: PTPerson ]! !

!PTPersonHtmlView methodsFor: 'as yet unclassified' stamp: 'tg 12/2/2008 21:59'!
renderContentOn: html

	html div class: 'personaldata'; with: [
		html div class: 'degree'; with: self person degree.
		html div class: 'jobtitle'; with: self person jobTitle.
		html div class: 'email'; with: [html anchor url: 'mailto:', self person email; with: self person email].
		self render: self person skills on: html.
	].
	html div class:'about'; with: [
		self render: self person document on: html
	]
! !

PRDefaultView subclass: #PTTeamHtmlView
	instanceVariableNames: 'team'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Team'!

!PTTeamHtmlView class methodsFor: 'as yet unclassified' stamp: 'tg 12/2/2008 21:50'!
isValidIn: aContext 
	^ (super isValidIn: aContext) and: [ aContext structure isKindOf: PTTeam ]! !

!PTTeamHtmlView methodsFor: 'as yet unclassified' stamp: 'tg 12/2/2008 22:00'!
renderContentOn: html

	html div class: 'team'; with: [
		self team persons do: [:each |
			html div class: 'member'; with: [
				html div class: 'name'; with: each title.
				html div class: 'personaldata'; with: [
					html div class: 'degree'; with: each degree.
					html div class: 'jobtitle'; with: each jobTitle.
					html div class: 'email'; with: [
						html anchor url: 'mailto:', each email; with: each email].
					self render: each skills on: html.
				].
				html div class:'about'; with: [
					self render: each document on: html
				]
			]
		]
	]! !

!PTTeamHtmlView methodsFor: 'as yet unclassified' stamp: 'tg 12/2/2008 21:50'!
team
	^ team ifNil: [ team := self find: PTTeam ]! !
